import { GraphQLResolveInfo, FieldNode, GraphQLObjectType } from 'graphql';
import { DBQuery, Plugin } from './types';
import { Database } from 'arangojs';
export declare type ResolverCreatorParams = {
    plugins?: {
        [name: string]: Plugin;
    };
    argumentResolvers?: {
        [pathPart: string]: any;
    };
    contextKey?: string;
    db?: Database;
    contextDbKey?: string;
};
export declare const createResolver: ({ plugins, argumentResolvers, db, contextDbKey, contextKey, }: ResolverCreatorParams) => (parent: any, args: {
    [key: string]: any;
}, context: any, info: GraphQLResolveInfo) => Promise<any>;
export declare const resolver: (parent: any, args: {
    [key: string]: any;
}, context: any, info: GraphQLResolveInfo) => Promise<any>;
declare type CommonExtractionParams = {
    info: GraphQLResolveInfo;
    parentQuery: DBQuery | undefined;
    parentType: GraphQLObjectType;
    path: string[];
    plugins: {
        [directiveName: string]: Plugin;
    };
    argumentResolvers: {
        [path: string]: any;
    };
};
export declare const extractQueriesFromField: ({ info, parentQuery, parentType, field, path, plugins, argumentResolvers, }: CommonExtractionParams & {
    field: FieldNode;
}) => DBQuery | null;
export {};
