export declare type DBQuery = {
    returnsList: boolean;
    fieldNames: string[];
    fieldQueries: {
        [name: string]: DBQuery;
    };
    paramNames: string[];
    params: DBQueryParams;
    plugins: PluginInstance[];
};
export declare type DBQueryParams = {
    args?: {
        [name: string]: any;
    };
};
export declare type QueryFieldMap = {
    [path: string]: DBQuery;
};
export declare type Plugin = {
    name: string;
    build: (args: {
        fieldName: string;
        directiveArgs: {
            [name: string]: any;
        };
        fieldArgs: {
            [name: string]: any;
        };
        returnsList: boolean;
        parentName: string;
    }) => string;
};
export declare type PluginInstance = {
    plugin: Plugin;
    directiveArgs: {
        [name: string]: any;
    };
};
